package org.jeecg.modules.system.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.system.entity.SysPermissionDataRule;
import org.jeecg.modules.system.entity.SysRolePermission;
import org.jeecg.modules.system.service.ISysPermissionDataRuleService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 数据规则
 * @author： jeecg-boot
 * @date：   2019-06-29
 * @version： V1.0
 */
@RestController
@RequestMapping("/system/sysPermissionDataRule")
@Slf4j
public class SysPermissionDataRuleController {
	@Autowired
	private ISysPermissionDataRuleService sysPermissionDataRuleService;
	
	/**
	  * 分页列表查询
	 * @param sysPermissionDataRule
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<SysPermissionDataRule>> queryPageList(SysPermissionDataRule sysPermissionDataRule,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<SysPermissionDataRule>> result = new Result<IPage<SysPermissionDataRule>>();
		QueryWrapper<SysPermissionDataRule> queryWrapper = QueryGenerator.initQueryWrapper(sysPermissionDataRule, req.getParameterMap());
		Page<SysPermissionDataRule> page = new Page<SysPermissionDataRule>(pageNo, pageSize);
		IPage<SysPermissionDataRule> pageList = sysPermissionDataRuleService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param sysPermissionDataRule
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<SysPermissionDataRule> add(@RequestBody SysPermissionDataRule sysPermissionDataRule) {
		Result<SysPermissionDataRule> result = new Result<SysPermissionDataRule>();
		try {
			sysPermissionDataRuleService.save(sysPermissionDataRule);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param sysPermissionDataRule
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<SysPermissionDataRule> edit(@RequestBody SysPermissionDataRule sysPermissionDataRule) {
		Result<SysPermissionDataRule> result = new Result<SysPermissionDataRule>();
		SysPermissionDataRule sysPermissionDataRuleEntity = sysPermissionDataRuleService.getById(sysPermissionDataRule.getId());
		if(sysPermissionDataRuleEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = sysPermissionDataRuleService.updateById(sysPermissionDataRule);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<SysPermissionDataRule> delete(@RequestParam(name="id",required=true) String id) {
		Result<SysPermissionDataRule> result = new Result<SysPermissionDataRule>();
		SysPermissionDataRule sysPermissionDataRule = sysPermissionDataRuleService.getById(id);
		if(sysPermissionDataRule==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = sysPermissionDataRuleService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<SysPermissionDataRule> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<SysPermissionDataRule> result = new Result<SysPermissionDataRule>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.sysPermissionDataRuleService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<SysPermissionDataRule> queryById(@RequestParam(name="id",required=true) String id) {
		Result<SysPermissionDataRule> result = new Result<SysPermissionDataRule>();
		SysPermissionDataRule sysPermissionDataRule = sysPermissionDataRuleService.getById(id);
		if(sysPermissionDataRule==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(sysPermissionDataRule);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<SysPermissionDataRule> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              SysPermissionDataRule sysPermissionDataRule = JSON.parseObject(deString, SysPermissionDataRule.class);
              queryWrapper = QueryGenerator.initQueryWrapper(sysPermissionDataRule, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<SysPermissionDataRule> pageList = sysPermissionDataRuleService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "数据规则列表");
      mv.addObject(NormalExcelConstants.CLASS, SysPermissionDataRule.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("数据规则列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<SysPermissionDataRule> listSysPermissionDataRules = ExcelImportUtil.importExcel(file.getInputStream(), SysPermissionDataRule.class, params);
              for (SysPermissionDataRule sysPermissionDataRuleExcel : listSysPermissionDataRules) {
                  sysPermissionDataRuleService.save(sysPermissionDataRuleExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listSysPermissionDataRules.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

  /***
   * @Title:数据规则授权
          * @Description:TODO
          * @param sysPermissionDataRule
          * @return org.jeecg.common.api.vo.Result
          * @exception
          * @author 陈创
          * @date 2019/7/1 13:12
          * @updatehistory:
   *   2019/7/1 13:12 修改
          */
  @PutMapping(value = "/updateDataRule")
  public Result updateDataRule(@RequestBody SysRolePermission sysRolePermission){
  	Result result=new Result();
	  try {
		  sysPermissionDataRuleService.updateDataRule(sysRolePermission);
		  result.setSuccess(true);
	  } catch (Exception e) {
		  e.printStackTrace();
		  result.error500("授权失败");
	  }
	  return result;
  }

  /***
   * @Title:已经授权的数据规则
          * @Description:TODO
          * @param [sysRolePermission]
          * @return org.jeecg.common.api.vo.Result<java.util.List<java.lang.String>>
          * @exception
          * @author 陈创
          * @date 2019/7/1 15:53
          * @updatehistory:
   *   2019/7/1 15:53 查询
          */
  @GetMapping(value = "getDataRuleIds")
  public Result<List<String>> getDataRuleIds(SysRolePermission sysRolePermission){
      Result<List<String>> result=new Result<>();
      List<String> dataRuleIdsList=sysPermissionDataRuleService.getDataRule(sysRolePermission);
      result.setResult(dataRuleIdsList);
      return result;
  }

}
